
********* Dependency ********
	Simulation environment can be established by command below. (Requring 'Anaconda')
	$ conda env create -f neuralEQ.yaml


******** How to run *********
	There are several testbenches to simulate various scenario.
	All simulations configs are defined in './config/config_defaults.py'
	Simulation results are generated in './results/$ANY_NAME
	At the first time, create directory './results' by "mkdir results"
	
	Scenario 1. Running conventional EQ and forward-backwarda algorithm for given channel and measuring BER
	$ make eqs NAME=$ANY_NAME
	
	Scenario 2. Running NeuralEQ training with specified SNR
	$ make train NAME=$ANY_NAME
	
	Scenario 3. Running pruning for given trained model with specified # of iterations
	$ make prune NAME=$ANY_NAME
	
	Scenario 4. Running evaluation for given model and channel
	$ make eval NAME=$ANY_NAME



********** Core files and descriptions *************
	Makefile : Running command is define in this file.
	FwdBwdNeuralEqV3.py : Proposed neural network, NeuralEQ, is defined in this file.
	eq.py : Conventional EQs and Forward-backward algorithm is defined in this file.
	eqs.py : Simulation of conventional EQ and FB algorithm is defined.
	train.py : Training of NeuralEQ is defined.
	eval.py : Evaluation of NeuralEQ is defined.
	prune.py : Prunning of NeuralEQ is defined

